#![feature(const_type_name)]
#![feature(let_chains)]
mod astreams;
mod database;
mod sec;
mod servek;
mod svc;

use database::db::DB;
use servek::servek::Server;
use svc::{auth::Auth, profiles::Profiler};

#[tokio::main]
async fn main() -> Result<(), anyhow::Error> {
    astreams::test().await;
    let db = DB::new(
        "localhost".to_owned(),
        "flabk".to_owned(),
        "flabk".to_owned(),
    )
    .await?;
    let profiler = Profiler::new(db.users());
    let auth = Auth::new(db.keys(), db.users()).await;
    Server::new(profiler, auth).listen_and_serve(8008).await;
    Ok(())
}
